/**
 * Created by GoLand.
 * User: xzghua@gmail.com
 * Date: 2021/7/30
 * Time: 8:28 下午
 */
package main

import (
	"fmt"
)

func main() {

	// A  1
	// AA 27 = 26+1
	// AB 28 = 26+2
	// BA 26+26+1
	// AAA 26*26*26

	//1*26^2 + 1*26+1*26^0 = 26*26+26+1 =

	fmt.Println(10 << 1)

	str := "AZ"
	strSli := str[:]

	fmt.Println('A', 'A'-'Z', strSli[0]-'A'+1, strSli[1]-'A'+1, 26*26+26+1, titleToNumber("AAA"))
}

func titleToNumber(columnTitle string) (res int) {
	// 先将字符串转成切片, 切片的好处是  'A' 是 rune类型, 比如'A' 对应的是 65, 'B'是 66,这样就知道了 'Z'是多少了,可以进行相减操作
	sli := columnTitle[:]
	// 获取切片长度,
	lens := len(columnTitle)
	// 比如 100(二进制) 转成十进制就是 1*2^2 + 0*2^1 + 0*2^0
	// 所以多少次方 是长度减一开始的
	lens--

	// 遍历切片,转成二进制
	for _, v := range sli {
		// 'A' 是1开始的,所以需要加一
		// 后面就是26的多少次方了
		res += int(v-'A'+1) * pow(26, lens)
		// 每挪一位,位数减一
		lens--
	}

	return res
}

// 多少次方的实现, math.Pow 也可以,不过是浮点型的,不想转了
func pow(n, p int) (res int) {
	// 默认值是1, 不然 int默认值是0,那么 0*任何值都是0
	res = 1
	for ; p > 0; p-- {
		res *= n
	}
	return
}
